package app.brest.testmin3d;
import android.app.Activity;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.PixelFormat;
import android.hardware.Camera;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageButton;
import android.widget.MediaController;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.VideoView;

import org.w3c.dom.Text;

import java.util.ArrayList;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

import app.brest.app.brest.ui.CameraPreview;
import app.brest.utils.JSONLoader;
import app.brest.utils.ResourceManager;
import app.brest.utils.SensorsManager;
import app.brest.utils.app.brest.game.Game;
import app.brest.utils.app.brest.game.LocatedResource;
import app.brest.utils.app.brest.game.Place;
import app.brest.utils.app.brest.game.Resource;
import app.brest.utils.app.brest.game.Stage;
import app.brest.utils.geometry.GPSPoint;
import min3d.core.Object3d;
import min3d.core.Object3dContainer;
import min3d.core.RendererActivity;
import min3d.parser.IParser;
import min3d.parser.Parser;
import min3d.vos.CameraVo;
import min3d.vos.Light;
import min3d.vos.Number3d;


public class ARActivity extends RendererActivity
{

    private CameraPreview mImageSurfaceView;
    private Camera camera;
    private FrameLayout cameraPreviewLayout;

    private Object3dContainer faceObject3D;
    private Button mOkButton;
    private TextView mAngle;
    private TextView mGps;
    private final Object mLock = new Object();
    protected boolean isPausing=false;
    protected static GPSPoint mLocation;
    protected static boolean mLocationUpdated=false;
    private Game mGame;


    public void init()
    {
        setContentView(R.layout.activity_main);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);


        cameraPreviewLayout = (FrameLayout)findViewById(R.id.camera_preview);

        camera = checkDeviceCamera();
        mImageSurfaceView = new CameraPreview(ARActivity.this, camera);

        mAngle = (TextView) findViewById(R.id.angle);
        mGps = (TextView) findViewById(R.id.gps);


        mOkButton = (Button) findViewById(R.id.button_catch);
        mOkButton.setVisibility(View.INVISIBLE);
        if(cameraPreviewLayout.getChildCount()<2)
        {
            cameraPreviewLayout.addView(mImageSurfaceView,0);
            cameraPreviewLayout.addView(_glSurfaceView,1);
        }

    }

    private Camera checkDeviceCamera() {
        Camera mCamera = null;
        try {
            mCamera = Camera.open();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return mCamera;
    }

    protected void onCreateSetContentView()
    {
        //init();

    }

    @Override
    protected void glSurfaceViewConfig()
    {
        // !important
        _glSurfaceView.setEGLConfigChooser(8,8,8,8, 16, 0);
        _glSurfaceView.getHolder().setFormat(PixelFormat.TRANSLUCENT);
    }

    @Override
    public void initScene()
    {
        // !important
        scene.clear();
        scene.backgroundColor().setAll(0x00000000);
        scene.lights().add(new Light());
        scene.lights().add(new Light());

        Light myLight = new Light();
        myLight.position.setZ(150);
        scene.lights().add(myLight);


        //IParser myParser = Parser.createParser(Parser.Type.OBJ, getResources(), "app.brest.testmin3d:raw/face_obj", true);
        //myParser.parse();



    }

    protected Number3d pos(float deltaAngle, int _radius)
    {
        float radius = _radius;
        return new Number3d((float)(radius*Math.sin(deltaAngle)),
                            0,
                            (float)(15+radius*Math.cos(deltaAngle))
                        );
    }

    protected boolean updateSceneResource()
    {

        ArrayList<LocatedResource> res = mGame.getResourcesNextToPlayer();
        final TextView tv = (TextView) findViewById(R.id.text_detected);
        final TextView tv2 = (TextView)findViewById(R.id.text_place);
        String toDisplay ="Detetected \n";
       // String dete = "Detected:\n";
        scene.clear();
        for (int i = 0; i < res.size(); i++) {
            Resource rr = res.get(i).getResource();
            Place p = res.get(i).getPlace();
            if(rr!=null) {
                toDisplay += "\t" + rr.getName() + " \n";
                //dete += "\t" + rr.getName() + "\n";
                Object3d oo = rr.get3DModel(this);
                CameraVo v = new CameraVo();

                v.target.y=mGame.getPlayer().getOrientationY()-315;

                //si utilisation de field et angle
                if(p.isUseAngle())
                    v.target.x=(float)(mGame.getPlayer().getOrientationX()-p.getAngle())+mGame.getPlayer().getOrientationZ()-270f;
                //si utilisation GPS pour l'angle
                else
                    v.target.x=(float)(mGame.getPlayer().getOrientationX()-mGame.getPlayer().getAngleWith(p))
                            +mGame.getPlayer().getOrientationZ()-270f;

                toDisplay += "    "+(float)(mGame.getPlayer().getAngleWith(p)) +"("+mGame.getPlayer().getXWith(p)+", "+mGame.getPlayer().getYWith(p) +")\n";
                //v.target.z=mGame.getPlayer().getOrientationZ()-270;
                scene.camera(v);
                scene.addChild(oo);
            }
        }

        final String td = toDisplay;
        mAngle.getHandler().post(new Runnable() {
            public void run() {
                tv2.setText(td);
            }
        });

        final String dete2 = mGame.getResourcesNextToPlayer2();
        tv.getHandler().post(new Runnable() {
            public void run() {
                tv.setText(dete2);
            }
        });


        return scene.numChildren()>0;
    }

    protected void onList()
    {
        Intent intent = new Intent(this, ARActivity.class);
        intent.putExtra("game", mGame);
        startActivity(intent);
    }

     @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        //mGame = (Game) getIntent().getSerializableExtra("game");
        mGame = Game.game();
        mGame.newSensorManager(this);



    }




    @Override
    /**
     * Verifie si on doit afficher des resources et gere le bouton de capture
     */
    public  void updateScene()
    {
        boolean isResource = false;
        synchronized (mLock) {
            if (!isPausing) {
                boolean b = mGame.precache3DResource(this);
                isResource = updateSceneResource();
                if(b)
                {
                    final Activity _this = this;
                    mAngle.getHandler().post(new Runnable() {
                        public void run() {
                            Toast.makeText(_this,"Localisé dans la zone", Toast.LENGTH_LONG);
                        }
                    });

                }
            }else
            {
                scene.clear();
                mGame.removeCached3DModels();
            }
        }

        if(isResource) {
            mOkButton.getHandler().post(new Runnable() {
                public void run() {
                    mOkButton.setVisibility(View.VISIBLE);
                }
            });
        }else
        {
            mOkButton.getHandler().post(new Runnable() {
                public void run() {
                    mOkButton.setVisibility(View.INVISIBLE);
                }
            });

        }
        mAngle.getHandler().post(new Runnable() {
            public void run() {
                mAngle.setText("Angle X: "+mGame.getPlayer().getOrientation()+"°\n Angle Y: "+
                                mGame.getPlayer().getOrientationY()
                                +"\n Angle Z: "+mGame.getPlayer().getOrientationZ()+"°");
            }
        });

        setGpsText();

    }


    @Override
    protected  void onResume() {
        super.onResume();
        init();
        mGame.onResume(this);
        scene.clear();
        synchronized (mLock)
        {
            isPausing=false;
        }
    }
    @Override
    protected  void onPause()
    {
        synchronized (mLock)
        {
            isPausing=true;
        }
        super.onPause();
        mGame.onPause(this);
        scene.clear();
        cameraPreviewLayout.removeViewAt(0);
        cameraPreviewLayout.removeViewAt(0);

    }

    public void finish()
    {
        mGame.stopSensors();
        super.finish();
    }

    public void setGpsText()
    {
        if(mLocationUpdated) {
            final GPSPoint gps = mLocation;
            mGps.getHandler().post(new Runnable() {

                public void run() {
                    mGps.setText("Latitude: " + gps.getX() + "°\n Longitude: " + gps.getY() + "\n");
                }
            });
            mLocationUpdated=false;
        }
    }


    public void onSaveInstanceState(Bundle savedInstanceState) {
        // Save the user's current game state
        savedInstanceState.putSerializable("game", mGame);

        // Always call the superclass so it can save the view hierarchy state
        super.onSaveInstanceState(savedInstanceState);
    }

    public void onClickPickUp(View v)
    {
        Resource res = null;
        boolean stageFinished = mGame.pickResource();
        boolean finished = false;
        res=mGame.getLatestResource();


        if(stageFinished)
        {
           finished = mGame.nextStage();
            Log.e("--____", "Finished="+finished);
        }

        if(finished)
        {
            Log.e("Finished", "Finished");
        }

        if(stageFinished)
        {
            Stage s = mGame.getCurrentStageObj();
            Resource stageRes = s.getResource();

            if(finished)
            {
                Log.e("--____", "Here");
                Intent intent2 = new Intent(this, EndActivity.class);
                startActivity(intent2);
            }

            Intent intent = new Intent(this, ViewerActivity.class);
            intent.putExtra("resource", stageRes );
            startActivity(intent);

            Intent intent2 = new Intent(this, TransferActivity.class);
            startActivity(intent2);
        }

        Intent intent = new Intent(this, ViewerActivity.class);
        intent.putExtra("resource", res );
        startActivity(intent);
        finish();
    }


    public static void setLocation(GPSPoint p)
    {
        mLocation = p;
        mLocationUpdated=true;
    }



}
